unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JwwGaibu, MyFunc, StdCtrls, ExtCtrls, ComCtrls ;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel1Resize(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    CloseFlag : Boolean ;
    comm,coms,commp : integer ;
    px,py : double ;
    pCol,pLtp,pWid : integer ;
    pa : array[1..40] of string ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
    procedure MemoAdd(s:string);
    procedure GetPoint(var x,y:double;s:string);
    procedure CommandLine ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   //
   CloseFlag := True ;
   comm := 0;
   coms := 0;
   commp:= 0;
   px := 0.0;
   py := 0.0;
   pCol := JG_CurCol;
   pLtp := JG_CurLtp;
   pWid := JG_CurWid;

   // f[^t@CJ܂
   OpenDatFile ;
   //
   Application.ProcessMessages ;
   Timer1.Interval:= 100;
   Timer1.Enabled := True ;
end;

// xăX^[g
//    ȂMemo1̉ʈړoȂ
procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Timer1.Enabled := False;
   Timer1.Interval:= 0;
   Memo1.SelStart := Length(Memo1.Lines.Text);
   Memo1.Perform(EM_SCROLLCARET,0,0);
   Memo1.SetFocus;
   Edit1.SetFocus;
   if (comm > 0) then begin
      Edit1.Text := '-';   // dummy
      CommandLine ;
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (CloseFlag) then begin
      comm := 0;
      coms := 0;
      pCol := JG_CurCol;
      pLtp := JG_CurLtp;
      pWid := JG_CurWid;
   end;
   // f[^t@Cۑ܂
   SaveDatFile ;
   // JWC_TEMP.TXTۑ܂
   SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   // ŏI
   EndJwwGaibu ;
end;

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);  Form1.Left  := SInt(s);
      ReadLn(F, s);  Form1.Top   := SInt(s);
      ReadLn(F, s);  Form1.Width := SInt(s);
      ReadLn(F, s);  Form1.Height:= SInt(s);

      ReadLn(F, s);  comm := SInt(s);
      ReadLn(F, s);  coms := SInt(s);
      ReadLn(F, s);  commp:= SInt(s);
      ReadLn(F, s);  px := SDbl(s);
      ReadLn(F, s);  py := SDbl(s);
      ReadLn(F, s);  pCol := SInt(s);
      ReadLn(F, s);  pLtp := SInt(s);
      ReadLn(F, s);  pWid := SInt(s);
      for i:=1 to 40 do begin
         ReadLn(F, s);  pa[i] := s ;
      end;

      CloseFile(F);
   except
      CloseFile(F);
   end;
   //
   fn := ChangeFileExt(Application.ExeName,'.txt') ;
   if not(FileExists(fn)) then exit;
   try
      Memo1.Lines.LoadFromFile(fn);
   except
      ;
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
   i : integer ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, IntToStr(Form1.Left));
      WriteLn(F, IntToStr(Form1.Top));
      WriteLn(F, IntToStr(Form1.Width));
      WriteLn(F, IntToStr(Form1.Height));

      WriteLn(F, IntToStr(comm));
      WriteLn(F, IntToStr(coms));
      WriteLn(F, IntToStr(commp));
      WriteLn(F, FloatToStr(px));
      WriteLn(F, FloatToStr(py));
      WriteLn(F, IntToStr(pCol));
      WriteLn(F, IntToStr(pLtp));
      WriteLn(F, IntToStr(pWid));

      for i:=1 to 40 do
         WriteLn(F, pa[i]);

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
   //
   fn := ChangeFileExt(Application.ExeName,'.txt') ;
   try
      Memo1.Lines.SaveToFile(fn);
   except
      ;
   end;
end;

// PanelTCYꍇ
procedure TForm1.Panel1Resize(Sender: TObject);
var
   i : integer ;
begin
   i := Panel1.ClientWidth - Label1.Width ;
   if (i < 1) then i:=1;
   Edit1.Width := i ;
end;

// [EnterL[]
procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      CommandLine ;
      Key := #0 ;
   end
   else if (Key = #27) then begin
      Edit1.Text := '[ESC]' ;
      CommandLine ;
      Key := #0 ;
   end;
end;

// ǉ
procedure TForm1.MemoAdd(s:string);
begin
   while (Memo1.Lines.Count > 100) do
      Memo1.Lines.Delete(0);
   Memo1.Lines.Add(s);
end;

// W擾
procedure TForm1.GetPoint(var x,y:double;s:string);
var
   i : integer ;
   s1,s2 : string ;
begin
   i := AnsiPos(',',s);
   if (i > 0) then begin
      s1:=Copy(s,1,i-1);
      s2:=Copy(s,i+1,Length(s));
   end
   else begin
      s1:=s;
      s2:='0.0';
   end;
   x := 0.0 ;
   y := 0.0 ;
   if (Copy(s1,1,1)='@') then begin
      x := px ;
      y := py ;
      s1:= Copy(s1,2,Length(s1));
   end;
   x := x + SDbl(s1);
   y := y + SDbl(s2);
   px:= x ;
   py:= y ;
end;

// R}hs
procedure TForm1.CommandLine ;
var
   s,cs : string ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   l : integer ;
begin
   s := Edit1.Text ;
   cs:= KTrim(AnsiUpperCase(s));
   if (cs = '[ESC]')or(comm <> 0)and(cs = '') then begin
      if (comm <> 0) then
         commp:= comm;
      comm := 0;
      coms := 0;
      MemoAdd('LZ');
      Label1.Caption := '';
      Edit1.Text := '';
      exit ;
   end;
   if (comm = 0) then begin
      if (cs = '') then begin
         comm := commp;
         coms := 0;
      end
      else if (cs = 'LAYERGROUP')or(cs = 'LAYERG')or(cs = 'LGROUP')
            or(cs = 'LGRP')or(cs = 'LG') then begin
         comm := 1;
         coms := 0;
      end
      else if (cs = 'LAYER')or(cs = 'LAY')or(cs = 'LA')or(cs = 'LY') then begin
         comm := 2;
         coms := 0;
      end
      else if (cs = 'COLOR')or(cs = 'COL')or(cs = 'CL')or(cs = 'LC') then begin
         comm := 3;
         coms := 0;
      end
      else if (cs = 'LTYPE')or(cs = 'LTP')or(cs = 'LT') then begin
         comm := 4;
         coms := 0;
      end
      else if (cs = 'LWIDTH')or(cs = 'WIDTH')or(cs = 'WID')or(cs = 'LW') then begin
         comm := 5;
         coms := 0;
      end
      else if (cs = 'MANUAL')or(cs = 'MAN')or(cs = 'HELP')or(cs = '?') then begin
         comm := 10;
         coms := 0;
      end
      else if (cs = 'LINE')or(cs = 'L') then begin
         comm := 11;
         coms := 0;
      end
      else if (cs = 'POINT')or(cs = 'TEN')or(cs = 'PO')or(cs = 'PT')or(cs = 'P') then begin
         comm := 12;
         coms := 0;
      end
      else if (cs = 'MARKER')or(cs = 'MARK')or(cs = 'MK')or(cs = 'M') then begin
         comm := 13;
         coms := 0;
      end
      else if (cs = 'CIRCLE')or(cs = 'CIRC')or(cs = 'CI')or(cs = 'C') then begin
         comm := 14;
         coms := 0;
      end
      else if (cs = 'ELLIPSE')or(cs = 'ELLI')or(cs = 'EL')or(cs = 'E') then begin
         comm := 15;
         coms := 0;
      end
      else if (cs = 'ARC')or(cs = 'AR')or(cs = 'A') then begin
         comm := 16;
         coms := 0;
      end;
   end;
   //
   Case(comm)of
    1:begin    // CO[v
         case(coms)of
         0: begin
               MemoAdd('CO[vݒ');
               Label1.Caption := 'ڲԸٰ߁';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               l := SInt(cs);
               if (l < 0)or(l > 15) then exit;
               pa[1] := IntToStr(l);
               MemoAdd('CO[vF'+pa[1]);
               S_LGrp(l);
               SendMem('hr');
               commp:= comm;
               comm := 0;
               coms := 0;
               CloseFlag := False ;
               close ;
            end;
         end;
      end;
    2:begin    // C
         case(coms)of
         0: begin
               MemoAdd('Cݒ');
               Label1.Caption := 'C';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               l := SInt(cs);
               if (l < 0)or(l > 15) then exit;
               pa[1] := IntToStr(l);
               MemoAdd('CF'+pa[1]);
               S_Lay(l);
               SendMem('hr');
               commp:= comm;
               comm := 0;
               coms := 0;
               CloseFlag := False ;
               close ;
            end;
         end;
      end;
    3:begin    // F
         case(coms)of
         0: begin
               MemoAdd('Fݒ(0: 1-9, 101-356:SXF)');
               Label1.Caption := 'F';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               l := SInt(cs);
               if (l >= 0)and(l <= 9)or(l >= 101)and(l <= 356) then else exit;
               if (l = 0) then l := JG_CurCol ;
               pCol := l;
               pa[1] := IntToStr(l);
               MemoAdd('FF'+pa[1]);
               Label1.Caption := '';
               Edit1.Text := '';
               commp:= comm;
               comm := 0;
               coms := 0;
            end;
         end;
      end;
    4:begin    // 
         case(coms)of
         0: begin
               MemoAdd('ݒ(0: 1-9,11-19, 31-62:SXF)');
               Label1.Caption := '';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               l := SInt(cs);
               if (l >= 0)and(l <= 9)or(l >= 11)and(l <= 19)
                or(l >= 31)and(l <= 62) then else exit;
               if (l = 0) then l := JG_CurLtp ;
               pLtp := l;
               pa[1] := IntToStr(l);
               MemoAdd('F'+pa[1]);
               Label1.Caption := '';
               Edit1.Text := '';
               commp:= comm;
               comm := 0;
               coms := 0;
            end;
         end;
      end;
    5:begin    // 
         case(coms)of
         0: begin
               MemoAdd('ݒ(-1: 0:{ 1- [1/100mmP])');
               Label1.Caption := '';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               l := SInt(cs);
               if (l >= -1)and(l <= 30000) then else exit;
               if (l = -1) then l := JG_CurWid ;
               pWid := l;
               pa[1] := IntToStr(l);
               MemoAdd('F'+pa[1]);
               Label1.Caption := '';
               Edit1.Text := '';
               commp:= comm;
               comm := 0;
               coms := 0;
            end;
         end;
      end;
   10:begin    // ?
          MemoAdd('LAYERGROUP(LG), LAYER(LY), COLOR(LC), LTYPE(LT), LWIDTH(LW) [Enter]=@\');
          MemoAdd('LINE(L), POINT(P), MARKER(M), CIRCLE(C), ELLIPSE(E), ARC(A) [ESC]=LZ');
          MemoAdd('p='+FloatToStr(JG_Jikukaku)+' LG='+IntToStr(JG_CurLGrp)+' LY='+IntToStr(JG_CurLay)+' LC='+IntToStr(pCol)+' LT='+IntToStr(pLtp)+' LW='+IntToStr(pWid));
          Label1.Caption := '';
          Edit1.Text := '';
          comm := 0;
          coms := 0;
      end;
   11:begin    // LINE
         case(coms)of
         0: begin
               MemoAdd('(LINE)}');
               Label1.Caption := 'n_';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('n_F'+pa[1]+','+pa[2]);
               Label1.Caption := 'I_';
               Edit1.Text := '';
               coms := 2;
            end;
         2: begin
               GetPoint(x2,y2,cs);
               pa[3] := FloatToStr(x2);
               pa[4] := FloatToStr(y2);
               MemoAdd('I_F'+pa[3]+','+pa[4]);
               x1 := SDbl(pa[1]);
               y1 := SDbl(pa[2]);
               S_Col(pCol,0);
               S_Ltp(pLtp,0);
               S_Wid(pWid);
               Rev(x3,y3,x1,y1,0.0,0.0,JG_Jikukaku);
               Rev(x4,y4,x2,y2,0.0,0.0,JG_Jikukaku);
               S_Line(x3,y3,x4,y4);
               SendMem('hr');
               coms := 3;
               CloseFlag := False ;
               close ;
            end;
         3: begin
               pa[1] := pa[3] ;
               pa[2] := pa[4] ;
               Label1.Caption := 'I_';
               Edit1.Text := '';
               coms := 2;
            end;
         end;
      end;
   12:begin    // _
         case(coms)of
         0: begin
               MemoAdd('_(POINT)}');
               Label1.Caption := 'zu_';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('zu_F'+pa[1]+','+pa[2]);
               S_PCol(pCol,0);
               Rev(x3,y3,x1,y1,0.0,0.0,JG_Jikukaku);
               S_Ten(x3,y3);
               SendMem('hr');
               coms := 0;
               CloseFlag := False ;
               close ;
            end;
         end;
      end;
   13:begin    // _}[J
         case(coms)of
         0: begin
               MemoAdd('_}[J(MARKER)}');
               Label1.Caption := '{';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               x1 := SDbl(cs);
               if (Abs(x1) <= _LIMIT) then x1 := 1.0;
               pa[3] := FloatToStr(x1);
               MemoAdd('{F'+pa[3]);
               Label1.Caption := 'px[]';
               Edit1.Text := '';
               coms := 2;
            end;
         2: begin
               x1 := SDbl(cs);
               pa[4] := FloatToStr(x1);
               MemoAdd('pxF'+pa[4]+'');
               MemoAdd('1: 2: 3: 4: 5: 6: 7: 8:` 9: 10:^ 11:');
               MemoAdd('-1: -2: -3:E -4:{ -5: -6: -7:~');
               Label1.Caption := 'ށ';
               Edit1.Text := '';
               coms := 3;
            end;
         3: begin
               l := SInt(cs);
               if (l < -7)or(l > 11) then l := -3;
               pa[5] := IntToStr(l);
               MemoAdd('ށF'+pa[5]);
               Label1.Caption := 'zu_';
               Edit1.Text := '';
               coms := 4;
            end;
         4: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('zu_F'+pa[1]+','+pa[2]);
               S_PCol(pCol,0);
               Rev(x3,y3,x1,y1,0.0,0.0,JG_Jikukaku);
               x4 := SDbl(pa[4]) + JG_Jikukaku ;
               S_Mark(x3,y3,SDbl(pa[3]),x4,SInt(pa[5]));
               SendMem('hr');
               coms := 5;
               CloseFlag := False ;
               close ;
            end;
         5: begin
               Label1.Caption := 'zu_';
               Edit1.Text := '';
               coms := 4;
            end;
         end;
      end;
   14:begin    // ~
         case(coms)of
         0: begin
               MemoAdd('~(CIRCLE)}');
               Label1.Caption := 'a';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               x1 := SDbl(cs);
               if (x1 <= _LIMIT) then exit ;
               pa[3] := FloatToStr(x1);
               MemoAdd('aF'+pa[3]);
               Label1.Caption := 'S_';
               Edit1.Text := '';
               coms := 2;
            end;
         2: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('S_F'+pa[1]+','+pa[2]);
               S_Col(pCol,0);
               S_Ltp(pLtp,0);
               S_Wid(pWid);
               Rev(x3,y3,x1,y1,0.0,0.0,JG_Jikukaku);
               S_Circle(x3,y3,SDbl(pa[3]));
               SendMem('hr');
               coms := 3;
               CloseFlag := False ;
               close ;
            end;
         3: begin
               Label1.Caption := 'S_';
               Edit1.Text := '';
               coms := 2;
            end;
         end;
      end;
   15:begin    // ȉ~
         case(coms)of
         0: begin
               MemoAdd('ȉ~(ELLIPSE)}');
               Label1.Caption := 'wa';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               x1 := SDbl(cs);
               if (x1 <= _LIMIT) then exit ;
               pa[3] := FloatToStr(x1);
               MemoAdd('waF'+pa[3]);
               Label1.Caption := 'xa';
               Edit1.Text := '';
               coms := 2;
            end;
         2: begin
               x1 := SDbl(cs);
               if (x1 <= _LIMIT) then exit ;
               pa[4] := FloatToStr(x1);
               MemoAdd('xaF'+pa[4]);
               Label1.Caption := 'px[]';
               Edit1.Text := '';
               coms := 3;
            end;
         3: begin
               x1 := SDbl(cs);
               pa[5] := FloatToStr(x1);
               MemoAdd('pxF'+pa[5]+'');
               Label1.Caption := 'S_';
               Edit1.Text := '';
               coms := 4;
            end;
         4: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('S_F'+pa[1]+','+pa[2]);
               S_Col(pCol,0);
               S_Ltp(pLtp,0);
               S_Wid(pWid);
               x2 := SDbl(pa[4]) / SDbl(pa[3]);
               Rev(x3,y3,x1,y1,0.0,0.0,JG_Jikukaku);
               x4 := SDbl(pa[5]) + JG_Jikukaku ;
               S_Arc(x3,y3,SDbl(pa[3]),0.0,0.0,x2,x4);
               SendMem('hr');
               coms := 5;
               CloseFlag := False ;
               close ;
            end;
         5: begin
               Label1.Caption := 'S_';
               Edit1.Text := '';
               coms := 4;
            end;
         end;
      end;
   16:begin    // ~
         case(coms)of
         0: begin
               MemoAdd('~(ARC)}');
               Label1.Caption := 'S_';
               Edit1.Text := '';
               coms := 1;
            end;
         1: begin
               GetPoint(x1,y1,cs);
               pa[1] := FloatToStr(x1);
               pa[2] := FloatToStr(y1);
               MemoAdd('S_F'+pa[1]+','+pa[2]);
               Label1.Caption := 'a';
               Edit1.Text := '';
               coms := 2;
            end;
         2: begin
               x1 := SDbl(cs);
               if (x1 <= _LIMIT) then exit ;
               pa[3] := FloatToStr(x1);
               MemoAdd('aF'+pa[3]);
               Label1.Caption := 'Ε';
               Edit1.Text := '';
               coms := 3;
            end;
         3: begin
               x1 := SDbl(cs);
               if (x1 <= _LIMIT) then exit ;
               pa[4] := FloatToStr(x1);
               MemoAdd('ΕF'+pa[4]);
               Label1.Caption := 'np[]';
               Edit1.Text := '';
               coms := 4;
            end;
         4: begin
               x1 := SDbl(cs);
               pa[5] := FloatToStr(x1);
               MemoAdd('npF'+pa[5]+'');
               Label1.Caption := 'Ip[]';
               Edit1.Text := '';
               coms := 5;
            end;
         5: begin
               x1 := SDbl(cs);
               pa[6] := FloatToStr(x1);
               MemoAdd('IpF'+pa[6]+'');
               Label1.Caption := 'Xp[]';
               Edit1.Text := '';
               coms := 6;
            end;
         6: begin
               x1 := SDbl(cs);
               pa[7] := FloatToStr(x1);
               MemoAdd('XpF'+pa[7]+'');
               S_Col(pCol,0);
               S_Ltp(pLtp,0);
               S_Wid(pWid);
               Rev(x3,y3,SDbl(pa[1]),SDbl(pa[2]),0.0,0.0,JG_Jikukaku);
               x4 := SDbl(pa[7]) + JG_Jikukaku ;
               S_Arc(x3,y3,SDbl(pa[3]),SDbl(pa[5]),SDbl(pa[6]),SDbl(pa[4]),x4);
               SendMem('hr');
               coms := 0;
               CloseFlag := False ;
               close ;
            end;
         end;
      end;
   end;
end;

end.
